package io.xjar.dir;

import java.io.IOException;
import io.xjar.key.XKey;
import io.xjar.XEntryFilter;
import io.xjar.XEncryptor;
import java.io.File;
import io.xjar.XEntryEncryptor;

public class XDirEncryptor extends XEntryEncryptor<File> implements XEncryptor
{
    public XDirEncryptor(final XEncryptor xEncryptor) {
        this(xEncryptor, null);
    }
    
    public XDirEncryptor(final XEncryptor xEncryptor, final XEntryFilter<File> filter) {
        super(xEncryptor, (XEntryFilter)filter);
    }
    
    public void encrypt(final XKey key, final File src, final File dest) throws IOException {
        if (src.isFile()) {
            final XEncryptor encryptor = (XEncryptor)(this.filtrate((Object)src) ? this.xEncryptor : this.xNopEncryptor);
            encryptor.encrypt(key, src, dest);
        }
        else if (src.isDirectory()) {
            final File[] files = src.listFiles();
            for (int i = 0; files != null && i < files.length; ++i) {
                this.encrypt(key, files[i], new File(dest, files[i].getName()));
            }
        }
    }
}
